<template>
  <div class="container">
    <h2>New Consumable</h2>
    <b-form-input
      v-model="item_id"
      required
      placeholder="item id"
      type="number">
    </b-form-input>
    <small>In case you don't know the item id, visit <nuxt-link to="/admin/items">items</nuxt-link></small>
    <b-form-input
      v-model="special_id"
      placeholder="special id"
      type="number">
    </b-form-input>
    <small>In case you don't know the special id, visit <nuxt-link to="/admin/specials">specials</nuxt-link></small>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      item_id: '',
      special_id: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.item_id * this.special_id > 0;
    }
  },
  methods: {
    submit() {
      let data = {
        consumable: {
          item_id: this.item_id,
          special_id: this.special_id
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/consumables',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.name = '';
      this.cost = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
